require "defines"

local chest
local loaded

game.onload(function()
	if not loaded then
		loaded = true
		if glob.canCraftChest ~= false then
			game.forces.player.recipes["heavy-chest"].enabled = game.forces.player.technologies["steel-processing"].researched
		end
		
		if glob.chest ~= nil then
			chest = glob.chest
		end
	end
end)

game.oninit(function()
	loaded = true
	
	if glob.canCraftChest ~= false then
		game.forces.player.recipes["heavy-chest"].enabled = game.forces.player.technologies["steel-processing"].researched
	end
end)

game.onevent(defines.events.onpreplayermineditem, function(event)
	local chestHasContents
	local chestContents
	local itemName
	local countBefore
	local countAfter
	local player = game.players[event.playerindex]
	
	if event.entity.name == "heavy-chest" then
		if chest == nil then
			chestContents = event.entity.getinventory(1).getcontents()
			
			for k,v in pairs(chestContents) do
				chestHasContents = true
				break
			end
			
			if chestHasContents then
				glob.chest = chestContents
				chest = glob.chest
				event.entity.getinventory(1).clear()
				
				itemName = "heavy-chest-picked-up"
			end
		end
		
		if itemName == nil then
			itemName = "heavy-chest"
		end
		
		countBefore = player.getitemcount(itemName)
		player.insert({name = itemName, count = 1})
		countAfter = player.getitemcount(itemName)
		if countBefore == countAfter then
			game.createentity({name = "item-on-ground", position = event.entity.position, stack = {name = itemName, count = 1}})
		end
		
--		if game.player.caninsert({name = itemName, count = 1}) then
--			game.player.insert({name = itemName, count = 1})
--		else
--			game.createentity({name = "item-on-ground", position = entity.position, stack = {name = itemName, count = 1}})
--		end
	end
end)

game.onevent(defines.events.onbuiltentity, function(event)
	local newChest
	
	if event.createdentity.name == "heavy-chest-picked-up" then
		newChest = game.createentity({name = "heavy-chest", position = event.createdentity.position, force = game.forces.player})
		event.createdentity.destroy()
		
		if chest ~= nil then
			for k,v in pairs(chest) do
				newChest.getinventory(1).insert({name = k, count = v})
			end
			chest = nil
			glob.chest = nil
		end
	end
end)

game.onevent(defines.events.onplayercrafteditem , function(event)
	if event.itemstack.name == "heavy-chest" then
		if glob.canCraftChest ~= false and game.forces.player.recipes["heavy-chest"].enabled then
			game.forces.player.recipes["heavy-chest"].enabled = false
			glob.canCraftChest = false
		end
	end
end)

game.onevent(defines.events.onentitydied, function(event)
	if event.entity.name == "heavy-chest" then
		glob.canCraftChest = nil
		game.forces.player.recipes["heavy-chest"].enabled = game.forces.player.technologies["steel-processing"].researched
	end
end)